﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using System.Drawing.Drawing2D;

namespace WindowsFormsApplication5
{
    public partial class GlossyKnopf : Button
    {
        public GlossyKnopf()
        {
            InitializeComponent();
            this.DoubleBuffered = true;
            this.FlatAppearance.BorderSize = 20;
            this.FlatAppearance.BorderColor = Color.Black;       
        }

        string _Text;
        Color _MouseOverFarbe1 = Color.LightBlue;
        Color _MouseOverFarbe2 = Color.Blue;

        Color _MouseDownFarbe1 = Color.LightBlue;
        Color _MouseDownFarbe2 = Color.Blue;

        Color _MouseClickFarbe1 = Color.LightGreen;
        Color _MouseClickFarbe2 = Color.Green;

        Color _ButtonBorderColor = Color.LightBlue;

        bool MausIstDrauf = false;
        bool MausKlickt = false;

        private void Zeichnen(object sender, PaintEventArgs e)
        {
            Rectangle rect = e.ClipRectangle;
            e.Graphics.SmoothingMode = SmoothingMode.HighQuality;
            e.Graphics.CompositingQuality = CompositingQuality.HighQuality;
            e.Graphics.TextRenderingHint = System.Drawing.Text.TextRenderingHint.ClearTypeGridFit;

            LinearGradientBrush br;

            if (!MausIstDrauf && !MausKlickt)
            {
                br = new LinearGradientBrush(rect, _MouseOverFarbe1, _MouseOverFarbe2, 90, true);
            }
            else if (MausIstDrauf && !MausKlickt)
            {
                br = new LinearGradientBrush(rect, _MouseDownFarbe1, _MouseDownFarbe2, 90, true);
            }
            else
            {
                br = new LinearGradientBrush(rect, _MouseClickFarbe1, _MouseClickFarbe2, 90, true);
            }
            
            e.Graphics.FillRectangle(br, rect);
            
            Rectangle r = rect;
            r.Width -= 1;
            r.Height -= 1;
            e.Graphics.DrawRectangle(new Pen(new SolidBrush(_ButtonBorderColor)), r);

            StringFormat stringFormat = new StringFormat();
            stringFormat.Alignment = StringAlignment.Center;
            stringFormat.LineAlignment = StringAlignment.Center;

            Font f = new Font("Arial", 8, FontStyle.Regular, GraphicsUnit.Point);
            if (_Text != "")
                e.Graphics.DrawString(_Text, f, new SolidBrush(Color.Black), rect, stringFormat);
        }

        private void KlickAnfang(object sender, EventArgs e)
        {
            MausKlickt = true;
            Invalidate();
        }

        private void KlickEnde(object sender, EventArgs e)
        {
            MausKlickt = false;
            Invalidate();
        }

        private void MausDrauf(object sender, EventArgs e)
        {
            MausIstDrauf = true;
            Invalidate();
            
        }

        private void MausRunter(object sender, EventArgs e)
        {
            MausIstDrauf = false;
            Invalidate();
        }

        [Category("Properties")]
        [Browsable(true)]
        [Description("Text der im Knopf angezeigt werden soll")]
        public string Anzeige
        {
            get { return _Text; }
            set { _Text = value; }
        }

        [Category("Properties")]
        [Browsable(true)]
        [Description("MouseOver Farbe1")]
        public Color MouseOverFarbe1
        {
            get { return _MouseOverFarbe1; }
            set { _MouseOverFarbe1 = value; }
        }

        [Category("Properties")]
        [Browsable(true)]
        [Description("MouseOver Farbe2")]
        public Color MouseOverFarbe2
        {
            get { return _MouseOverFarbe2; }
            set { _MouseOverFarbe2 = value; }
        }

        [Category("Properties")]
        [Browsable(true)]
        [Description("MouseDown Farbe1")]
        public Color MouseDownFarbe1
        {
            get { return _MouseDownFarbe1; }
            set { _MouseDownFarbe1 = value; }
        }

        [Category("Properties")]
        [Browsable(true)]
        [Description("MouseDown Farbe2")]
        public Color MouseDownFarbe2
        {
            get { return _MouseDownFarbe2; }
            set { _MouseDownFarbe2 = value; }
        }

        [Category("Properties")]
        [Browsable(true)]
        [Description("MouseClick Farbe1")]
        public Color MouseClickFarbe1
        {
            get { return _MouseClickFarbe1; }
            set { _MouseClickFarbe1 = value; }
        }

        [Category("Properties")]
        [Browsable(true)]
        [Description("MouseClick Farbe2")]
        public Color MouseClickFarbe2
        {
            get { return _MouseClickFarbe2; }
            set { _MouseClickFarbe2 = value; }
        }

        [Category("Properties")]
        [Browsable(true)]
        [Description("Button Border Color")]
        public Color ButtonBorderColor
        {
            get { return _ButtonBorderColor; }
            set { _ButtonBorderColor = value; }
        }

    }
}
